<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: age_suburb_report_page.php,v 1.2 2004/10/14 10:50:36 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR . 'common_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    # Get GET Variables
    $f_format = gpc_get_string( 'format',  'html' );

    disable_timeout();

    $diocese_db->connect();

    #
    # Generic sort function to sort an array based on a field of its records.
    #
    
    $t_core_parishioners = table( 'core_parishioners' );
    $t_core_family_members = table( 'core_family_members' );
    $t_core_families = table( 'core_families' );
    $t_core_addresses = table( 'core_addresses' );
    // $query = "SELECT p.parishioner_id as parishioner_id, a.suburb_id as suburb_id FROM $t_core_parishioners p, $t_core_family_members fm, $t_core_families f, $t_core_addresses a WHERE ( p.approved = 1 ) AND p.parishioner_id = fm.parishioner_id AND fm.family_id = f.family_id AND (f.approved = 1) AND ( f.address_id = a.address_id )";
    $query = "SELECT parishioner_id FROM $t_core_parishioners WHERE approved=1";

    if ( access_limited_to_one_parish() )
    {
        $query .= " AND primary_parish_id = " . access_get_parish_id();
    }

    $t_result = &$diocese_db->execute( $query );
    
	$t_count = array();
	$t_count['?'] = array();
	$t_count['X'] = array();
	$t_parishioners = array();
	$t_parishioners['?'] = array();
	$t_parishioners['X'] = array();

	$t_parishioners_count = 0;

    while ( !$t_result->EOF )
    {
    	++$t_parishioners_count;
    	
        $t_parishioner_id = $t_result->fields['parishioner_id'];
        $t_parishioner = $diocese_db->parishioner_load( $t_parishioner_id );

        $query = "SELECT a.suburb_id as suburb_id FROM $t_core_parishioners p, $t_core_family_members fm, $t_core_families f, $t_core_addresses a WHERE ( p.parishioner_id = $t_parishioner_id ) AND p.parishioner_id = fm.parishioner_id AND fm.family_id = f.family_id AND ( f.address_id = a.address_id )";
        $t_result2 = &$diocese_db->execute( $query );
        
        if ( !$t_result2->EOF )
        	$t_suburb_id = $t_result2->fields['suburb_id'];
        else
			$t_suburb_id = '?';

		// @@@ TODO: Get family member id from parishioner
		// @@@ TODO: Get family id from family member id
		// @@@ TODO: Get address id from family
		// @@@ TODO: Get suburb_id from address
		// @@@ TODO: If any of the above is not found, then set $t_suburb_id to -1 or ?.
        // $t_suburb_id = $t_result->fields['suburb_id'];

		$date = new Date();
		$date->FromString( $t_parishioner->get_date_of_birth() );

		$t_name = $t_parishioner->get_first_name() . ' ' . $t_parishioner->get_last_name() . ' (' . $date->YearToYYYY() . ')';
		
		$t_year_of_birth = $date->YearToYYYY();
		if ( $t_year_of_birth === '????' )
		{
			if ( isset( $t_count['?'][$t_suburb_id] ) )
			{
				$t_count['?'][$t_suburb_id]++;
				$t_parishioners['?'][$t_suburb_id][] = $diocese_db->parishioner_load( $t_parishioner_id );
			}
			else
			{
				$t_count['?'][$t_suburb_id] = 1;
				$t_parishioners['?'][$t_suburb_id] = array( $diocese_db->parishioner_load( $t_parishioner_id ) );
			}
		}
		else
		{
			$t_year_of_today = date( 'Y' );

			$t_age = (int)$t_year_of_today - (int)$t_year_of_birth;
			
			if ( ( $t_age < 0 ) || ( $t_age > 120 ) )
			{
				if ( isset( $t_count['X'][$t_suburb_id] ) )
				{
					$t_count['X'][$t_suburb_id]++;
					$t_parishioners['X'][$t_suburb_id][] = $diocese_db->parishioner_load( $t_parishioner_id );
				}
				else
				{
					$t_count['X'][$t_suburb_id] = 1;
					$t_parishioners['X'][$t_suburb_id] = array( $diocese_db->parishioner_load( $t_parishioner_id ) );
				}
			}
			else
			{
				if ( isset( $t_count[$t_age][$t_suburb_id] ) )
				{
					$t_count[$t_age][$t_suburb_id]++;
					$t_parishioners[$t_age][$t_suburb_id][] = $diocese_db->parishioner_load( $t_parishioner_id );
				}
				else
				{
					$t_count[$t_age][$t_suburb_id] = 1;
					$t_parishioners[$t_age][$t_suburb_id] = array( $diocese_db->parishioner_load( $t_parishioner_id ) );
				}
			}
		}

        $t_result->MoveNext();
    }
    
    $t_count[-2] = $t_count['X'];
	$t_count[-1] = $t_count['?'];

	unset( $t_count['X'] );
	unset( $t_count['?'] );

	ksort( $t_count );
	
//	foreach( $t_count as $t_age => $t_suburbs )
//		foreach( $t_suburbs as $t_suburb_id => $t_number )
//			ksort( $t_count[$t_age] );

	$t_count['X'] = $t_count[-2];
	$t_count['?'] = $t_count[-1];

	unset( $t_count[-1] );
	unset( $t_count[-2] );

    # Execute the template
    $template->assign( 'count', $t_count );
    $template->assign( 'parishioners', $t_parishioners );

    if ( $f_format === 'csv' )
    {
        $t_filename = 'age_suburb_report.csv';
        header( 'Content-Type: text/plain; name=' . $t_filename );
        header( 'Content-Transfer-Encoding: BASE64;');
        header( 'Content-Disposition: attachment; filename=' . $t_filename );
        $template->run( 'age_suburb_report_csv' );
    }
    else
    {
        $template->run( 'age_suburb_report_page' );
    }
?>