<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: alpha_parishioners_report_page.php,v 1.2 2004/10/14 10:50:36 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR . 'common_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    # Get GET Variables
    $f_format = gpc_get_string( 'format',  'html' );

    disable_timeout();

    $diocese_db->connect();

	$t_core_parishioners = table( 'core_parishioners' );
    $t_core_families = table( 'core_families' );
    $t_core_family_members = table( 'core_family_members' );
    $t_core_addresses = table( 'core_addresses' );
    $t_core_suburbs = table( 'core_suburbs' );

    $query = "SELECT p.parishioner_id as parishioner_id, fm.member_id as family_member_id, f.family_id as family_id 
              FROM $t_core_parishioners p, $t_core_families f, $t_core_family_members fm
              WHERE ( p.approved = 1 ) AND ( p.date_of_decease = '????-??-??' ) AND 
                    ( fm.parishioner_id = p.parishioner_id ) AND ( f.family_id = fm.family_id )";

    if ( access_limited_to_one_parish() )
    {
        $query .= " AND ( p.primary_parish_id = " . access_get_parish_id() . ')';
        
        $t_parish = &$diocese_db->parish_load( access_get_parish_id() );
        $t_parish_name = $t_parish->get_name();
    }
    else
    {
        $t_parish_name = '';
    }

    $query .= " ORDER BY p.first_name ASC, p.last_name ASC";

    $t_result = &$diocese_db->execute( $query );

	$t_parishioners_details = array();

    while ( !$t_result->EOF )
    {
        $t_parishioner_id = $t_result->fields['parishioner_id'];
        $t_parishioner = $diocese_db->parishioner_load( $t_parishioner_id );

        $t_family_id = $t_result->fields['family_id'];
        $t_family = $diocese_db->family_load( $t_family_id );

        $t_address_id = $t_family->get_address_id();
        $t_address = $diocese_db->address_load( $t_address_id );
        	
		$t_parishioner_details = array();
		$t_parishioner_details["Id"] = $t_parishioner->get_id();
		$t_parishioner_details["Surname"] = $t_parishioner->get_last_name();
		$t_parishioner_details["FirstName"] = $t_parishioner->get_first_name();
		$t_parishioner_details["Mobile"] = $t_parishioner->get_mobile_number();
		$t_parishioner_details["HomePhone"] = $t_family->get_home_phone();
		$t_parishioner_details["Street"] = $t_address->get_street_details();
		$t_parishioner_details["Suburb"] = $t_address->get_suburb();

		$t_parishioners_details[] = $t_parishioner_details;

        $t_result->MoveNext();
    }

    # Execute the template
    $template->assign( 'parishioners_details', $t_parishioners_details );
    $template->assign( 'parish_name', $t_parish_name );

    switch( $f_format )
    {
    case 'csv':
        $t_filename = 'visitation_report.csv';
        header( 'Content-Type: text/plain; name=' . $t_filename );
        header( 'Content-Transfer-Encoding: BASE64;');
        header( 'Content-Disposition: attachment; filename=' . $t_filename );
        $template->run( 'alpha_parishioner_report_csv' );
        break;
    case 'print':
        $template->run( 'alpha_parishioner_report_print' );
        break;
    case 'html':
        $template->run( 'alpha_parishioner_report_page' );
        break;
    }
?>