<?php
    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'address_inc.php' );
    require_once( $t_src_path . 'utils_api_inc.php' );

    access_ensure_not_standalone();

    $diocese_db->connect();

    if ( access_limited_to_one_parish() )
        $t_parishes = parish_get_id_name_map();  
    else
        $t_parishes = parish_get_id_name_map( array( '' => 'any' ) );  

    $t_parish_ids = array_keys( $t_parishes );
    $t_parish_names = array_values( $t_parishes );

    $t_states   = states_get_id_name_map( array( '' => 'any' ) );
    $t_state_ids = array_keys( $t_states );
    $t_state_names = array_values( $t_states );

    # Prepare and Execute the template

    $template->assign( 'action_page',   'family_list_page.php' );
    $template->assign( 'parish_ids',    $t_parish_ids );
    $template->assign( 'parish_names',  $t_parish_names );
    $template->assign( 'parish_id',     'parish_id' );
    $template->assign( 'state_ids',     $t_state_ids );
    $template->assign( 'state_initials', $t_state_names );
    $template->assign( 'state_id',      'state_id' );
    $template->assign( 'suburb',        'suburb' );
    $template->assign( 'last_name',     'last_name' );
    $template->assign( 'home_phone',    'home_phone' );
    $template->assign( 'home_fax',      'home_fax' );
    $template->assign( 'post_code',      'post_code' );

    $template->run( 'family_search_page' );
?>
