<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: family_view_page.php,v 1.10 2004/04/15 15:03:19 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR . 'common_inc.php' );

    require_once( $src_path . 'family_inc.php' );
    require_once( $src_path . 'family_member_inc.php' );
    require_once( $src_path . 'parishioner_inc.php' );
    require_once( $src_path . 'database_inc.php' );
    require_once( $src_path . 'address_inc.php' );
    require_once( $src_path . 'gpc_api_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    $family_id = gpc_get_int( 'family_id', 0 );
    $pass = gpc_get_string( 'pass', '' );

    $diocese_db->connect();

    $view_even_if_standalone = false;
    if ( $pass != '' )
    {
        $t_calculated_pass = access_encrypt( 'family_view' . $family_id );
        $view_even_if_standalone = ( $pass == $t_calculated_pass );
    }

    if ( !$view_even_if_standalone )
        access_ensure_not_standalone();

    access_ensure_to_family( $family_id );

    $family =& $diocese_db->family_load( $family_id );
    if ( $family === false )
    {
        $template->assign( 'family_id', $family_id );
        $template->run( 'family_not_found' );
        exit;
    }

    $address =& $diocese_db->address_load( $family->get_address_id() );

    $family_members = $family->get_family_members();
    $parishioners = array();
    foreach ( $family_members as $family_member )
    {
        $parishioners[] =& $diocese_db->parishioner_load( $family_member->get_parishioner_id() );
    }

    $t_duplicate_ids = family_get_duplicate_ids( $family_id );

    $template->assign( 'family',          $family );
    $template->assign( 'family_members',  $family->get_family_members() );
    $template->assign( 'address',         $address );
    $template->assign( 'parishioners',    $parishioners );
    $template->assign( 'standalone',      access_is_standalone() );
    $template->assign( 'duplicate_ids',   $t_duplicate_ids );
    $template->assign( 'family_approve_action_page', 'family_approve.php' );
    $template->assign( 'family_delete_action_page', 'family_delete.php' );

    $template->run( 'family_view_page' );
?>
