<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: import_api_inc.php,v 1.6 2004/03/19 15:08:32 vboctor Exp $
    # -------------------------------------------------------------------------

    function relation_normalise( $p_relation )
    {
        $relation = trim( $p_relation );
        $relation = str_replace( '-', '', $relation );
        $relation = str_replace( ' ', '', $relation );
        $relation = str_replace( "\t", '', $relation );
	$relation = strtoupper( $relation );
        return $relation;
    }

    function relation_is_valid( $p_relation )
    {
        $relation = relation_normalise( $p_relation );

        switch ( $relation )
        {
        case 'FATHER':
        case 'HUSBAND':
        case 'H':
        case 'F':
        case 'MOTHER':
        case 'WIFE':
        case 'M':
        case 'W':
        case 'D':
        case 'DAUGHTER':
        case 'SON':
        case 'CHILD':
        case 'SINGLE':
        case 'GRANDFATHER':
        case 'GRANDMOTHER':
        case 'GRANDSON':
        case 'GRANDDAUGHTER':
            return true;
        }

	# S is not valid this it can be single or son.

        return false;
    }

    function relation_to_family_role( $p_relation )
    {
        $relation = relation_normalise( $p_relation );

        switch ( $relation )
        {
        case 'FATHER':
        case 'HUSBAND':
        case 'H':
        case 'F':
            return 'H';

        case 'MOTHER':
        case 'WIFE':
        case 'M':
        case 'W':
            return 'W';

        case 'DAUGHTER':
        case 'SON':
        case 'CHILD':
        case 'D':
            return 'C';

        case 'GRANDFATHER':
            return 'GF';

        case 'GRANDMOTHER':
            return 'GM';

        case 'GRANDSON':
        case 'GRANDDAUGHTER':
            return 'GC';

        case 'SINGLE':
            return 'S';
        }

        return false;
    }

    function relation_to_gender( $p_relation )
    {
        $relation = relation_normalise( $p_relation );

        switch ( $relation )
        {
        case 'FATHER':
        case 'HUSBAND':
        case 'SON':
        case 'GRANDFATHER':
        case 'GRANDSON':
        case 'BROTHER':
        case 'SONINLAW':
        case 'BROTHERINLAW':
        case 'FATHERINLAW':
        case 'NEPHEW':
        case 'F':
        case 'H':
            return 'M';

        case 'MOTHER':
        case 'WIFE':
        case 'DAUGHTER':
        case 'GRANDMOTHER':
        case 'GRANDDAUGHTER':
        case 'SISTER':
        case 'DAUGHTERINLAW':
        case 'SISTERINLAW':
        case 'MOTHERINLAW':
        case 'NEICE':
        case 'D':
        case 'M':
        case 'W':
            return 'F';
        }

        return false;
    }

    # remove values like N/A (not available)
    function preprocess_value( $p_value )
    {
        $value = trim( $p_value );
        $value = strtoupper( $value );

        switch ( $value )
        {
            case '':
            case 'NA':
            case 'N/A':
                return '';
        }

        // simulate that imported string are coming from $_GET or $_POST so that
        // the database_inc.php assumptions about the escaping are not broken.
        if ( get_magic_quotes_gpc() )
            $p_value = addslashes( $p_value );

        return $p_value;
    }

    # remove time sub-field from date fields
    function remove_time_from_date_time( $p_date_time )
    {
        return trim ( str_replace( '0:00:00', '', $p_date_time ) );
    }
?>
