<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: parish_view_page.php,v 1.4 2004/04/02 23:54:28 vboctor Exp $
    # -------------------------------------------------------------------------

    $src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR;

    require_once( $src_path . 'common_inc.php' );
    require_once( $src_path . 'parish_inc.php' );
    require_once( $src_path . 'database_inc.php' );
    require_once( $src_path . 'address_inc.php' );
    require_once( $src_path . 'gpc_api_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    $parish_id = gpc_get_int( 'parish_id', 0 );

    $parish = false;

    # if valid id, then load info from database
    if ( Parish::is_valid_id( $parish_id ) && ( $parish_id != 0 ) )
    {
        $diocese_db->connect();
        $parish =& $diocese_db->parish_load( $parish_id );
    }

    access_ensure_to_parish( $parish_id );

    # is parish not in db?
    if ( $parish === false )    # if parishioner not found
    {
        $template->assign( 'parish_id', $parish_id );
        $template->run( 'parish_not_found' );
	exit;
    }

    $address =& $diocese_db->address_load( $parish->get_address_id() );

    $template->assign( 'parish',  $parish );
    $template->assign( 'address', $address );
    $template->run( 'parish_view_page' );
?>