<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: parishioner_add_page.php,v 1.2 2004/03/08 11:52:12 vboctor Exp $
    # -------------------------------------------------------------------------

    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'utils_api_inc.php' );
    require_once( $t_src_path . 'gpc_api_inc.php' );
    require_once( $t_src_path . 'parishioner_inc.php' );
    require_once( $t_src_path . 'family_member_inc.php' );
    require_once( $t_src_path . 'parish_inc.php' );

    $family_id = gpc_get_int( 'family_id', 0 );

    $diocese_db->connect();

    // Family Roles
    $t_family_roles = family_member_get_role_id_name_map();
    $t_family_role_ids = array_keys( $t_family_roles );
    $t_family_roles = array_values( $t_family_roles );

    // Genders
    $t_genders = gender_get_id_name_map();
    $t_gender_id = array_keys( $t_genders );
    $t_gender = array_values( $t_genders );

    // Parishes
    $t_parishes = parish_get_id_name_map();
    $t_parish_ids = array_keys( $t_parishes );
    $t_parish_names = array_values( $t_parishes );

    // Prepare and Execute the template
    $template->assign( 'action_page',     'parishioner_add.php' );
    $template->assign( 'parish_ids',      $t_parish_ids );
    $template->assign( 'parish_names',    $t_parish_names );
    $template->assign( 'family_roles',    $t_family_roles );
    $template->assign( 'family_role_ids', $t_family_role_ids );
    $template->assign( 'gender',          $t_gender );
    $template->assign( 'gender_id',       $t_gender_id );

    $template->assign( 'title',               'title' );
    $template->assign( 'parish_id',           'parish_id' );
    $template->assign( 'first_name',          'first_name' );
    $template->assign( 'middle_name',         'middle_name' );
    $template->assign( 'last_name',           'last_name' );
    $template->assign( 'email',               'email' );
    $template->assign( 'mobile_phone',        'mobile_phone' );
    $template->assign( 'date_of_birth',       'date_of_birth' );
    $template->assign( 'primary_parish_id',   'primary_parish_id' );
    $template->assign( 'secondary_parish_id', 'secondary_parish_id' );

    $template->run( 'parishioner_add_page' );
?>
