<?php
/*
#----------------------------------------------------------------------------------------------
#
#  Reference:  	E-ARK  -  Census Management Page
#
#  File:     	~/parishioner_admin.php 
#  Project:    	E-ARK
#  Version:     $Id: parishioner_admin.php,v 1.5 2004/05/01 01:26:21 vboctor Exp $	
#  State:       Beta
#  Author:      Ian Atherton
#  Creation:    17/03/2004
#
#
#  Comments:    
#
#  Routines:
#       Routine                     Date            Description
#       -----------------------------------------------------------------------
#
#
#  Update History:
#       -----------------------------------------------------------------------
#       $Log: parishioner_admin.php,v $
#       Revision 1.5  2004/05/01 01:26:21  vboctor
#       M parishioner_admin.php
#       M templates/family_add_member.tpl
#       M templates/family_edit_member.tpl
#       - Fixed #945677: Unable to set secondary parish on one-parish-installations.
#
#       Revision 1.4  2004/04/15 14:44:39  vboctor
#       Added occupation field to parishioner (in database, in view page, in add, in edit)
#
#       Revision 1.3  2004/04/14 14:14:51  iatherton
#       Added Parishioner detail editing
#
#       Revision 1.2  2004/04/14 05:06:34  iatherton
#       Modifed to get family information, to allow family_add_member.tpl to use the
#       current families parish_id as the default parish_id
#
#       Revision 1.1  2004/04/13 10:54:40  iatherton
#       Code to manage parishioner updates and additions
#
#
#
#  Documentation Details:
#       -----------------------------------------------------------------------
#       Code Documenton:        
#       Author:                 Ian Atherton
#       Contact Number:         0409656609
#       Email:                  Iatherton@users.sourceforge.net 
#
#
#  Terms of Use:
#       -----------------------------------------------------------------------
#  	Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
#  	This program is distributed under the terms and conditions of the GPL
#  	See the README and LICENSE files for details
#
#----------------------------------------------------------------------------------------------
*/
 
    require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR . 'common_inc.php' );

    require_once( $src_path . 'family_inc.php' );
    require_once( $src_path . 'family_member_inc.php' );
    require_once( $src_path . 'parishioner_inc.php' );
    require_once( $src_path . 'database_inc.php' );
    require_once( $src_path . 'address_inc.php' );
    require_once( $src_path . 'gpc_api_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );
 
     //--------------------------------------------------------
    // CHECK SUPPLIED VALUES BEFORE RUNNING SCRIPT      
    //--------------------------------------------------------
    if($cfg_standalone == true)					                        // System is not in standalone mode
    {
            trigger_error("Illegal Action",E_USER_ERROR);
            exit;
    }

    
  
    $diocese_db->connect();
    
    //--------------------------------------------------------
    // Direct Page functionality
    //--------------------------------------------------------
    switch ($option)
	{
		case 'delete':
	
		    if($family_id == '')					                            // Family_id exists
            {
                trigger_error("Family_id is invalid",E_USER_ERROR);
                exit;
            }
            if($parishioner_id == '')					                        // parishioner_id exists
            {
                trigger_error("parishioner_id is invalid",E_USER_ERROR);
                exit;
            }
	        if($YES=='Y')                                                       // Check that deletion confirmed
	        {
                family_delete_parishioner( $parishioner_id, $family_id );       // Delete parishioner
            }
            
            //--------------------------------------------------------
            // Redirect to family_view_page to display details about the added family
            //--------------------------------------------------------
	        $t_url = 'family_view_page.php?family_id=' . $family_id ;
	        header_redirect( $t_url );
	        
		break;
	    
	    case 'add':
	    
	    	//#----------------------------------------------------------------------------------------------
	        //# DEFINE OR RETRIEVE DATA FOR PAGE
	        //#----------------------------------------------------------------------------------------------
	        $t_parishes = parish_get_id_name_map();                               // Get parish mapping (parish_inc.php)
	        $t_parish_ids = array_keys( $t_parishes );                            // Get Internal parish values
	        $t_parish_names = array_values( $t_parishes );                        // Get Parish Names for page

	        $t_secondary_parishes = parish_get_id_name_map( array(), false );     // Get all parishes (not just the accessible ones)
	        $t_secondary_parish_ids = array_keys( $t_secondary_parishes );        // Get Internal parish values
	        $t_secondary_parish_names = array_values( $t_secondary_parishes );    // Get Parish Names for page

	        $t_roles = family_member_get_role_id_name_map();			// Get Roler Mapping ( )
	        $t_role_ids = array_keys( $t_roles );					// Get Role Values
	        $t_role_names = array_values( $t_roles);				// Get Role Names
	        $t_genders = gender_get_id_name_map();				// Get Genders Mapping
	        $t_gender_ids = array_keys( $t_genders );				// Get Gender Values
	        $t_gender_names = array_values( $t_genders );				// Get Gender Names
	        $t_title_names = title_get_all();					// Get title values


	        //#----------------------------------------------------------------------------------------------
	        //# Prepare and Execute the template
	        //#----------------------------------------------------------------------------------------------
	        $template->assign( 'parish_ids',         $t_parish_ids );             // Assign values for 'parish_ids'
	        $template->assign( 'parish_names',       $t_parish_names );           // Assign values for 'parish_names'
	        $template->assign( 'secondary_parish_ids',   $t_secondary_parish_ids );   // Assign values for 'secondary_parish_ids'
	        $template->assign( 'secondary_parish_names', $t_secondary_parish_names ); // Assign values for 'secondary_parish_names'
	        $template->assign( 'family_name',        $family_name );              // Assign values for 'family_name'
	        $template->assign( 'role_ids',           $t_role_ids );               // Assign values for 'role_ids'
	        $template->assign( 'role_names',         $t_role_names );             // Assign values for 'role_names'
	        $template->assign( 'gender_ids',         $t_gender_ids );             // Assign values for 'gender_ids'
	        $template->assign( 'gender_names',       $t_gender_names );           // Assign values for 'gender_names'
	        $template->assign( 'title_names',        $t_title_names );            // Assign values for 'title_names'
	        //#----------------------------------------------------------------------------------------------
	        $template->assign( 'title',               'title[]' );                // Assign Field Name
	        $template->assign( 'first_name',          'first_name[]' );           // Assign Field Name
	        $template->assign( 'middle_name',         'middle_name[]' );          // Assign Field Name
	        $template->assign( 'last_name',           'last_name[]' );            // Assign Field Name
	        $template->assign( 'email',               'email[]' );                // Assign Field Name
                $template->assign( 'occupation',          'occupation[]' );           // Assign Field Name
	        $template->assign( 'mobile_phone',        'mobile_phone[]' );         // Assign Field Name
	        $template->assign( 'dob',                 'dob[]' );			// Assign Field Name
	        $template->assign( 'mob',                 'mob[]' );			// Assign Field Name
	        $template->assign( 'yob',                 'yob[]' );			// Assign Field Name
	        $template->assign( 'gender',              'gender[]' );		// Assign Field Name
	        $template->assign( 'primary_parish_id',   'primary_parish_id[]' );    // Assign Field Name
	        $template->assign( 'secondary_parish_id', 'secondary_parish_id[]' );  // Assign Field Name
	        $template->assign( 'role',                'role[]' );                 // Assign Field Name
	        $template->assign( 'home_number',                $home_number );                 // Assign Field Name
	        //#----------------------------------------------------------------------------------------------

	        access_ensure_to_family( $family_id );
           	$family =& $diocese_db->family_load( $family_id );
          	if ( $family === false )
           	{
                	$template->assign( 'family_id', $family_id );
                	$template->run( 'family_not_found' );
                	exit;
           	}	
		$template->assign( 'family',          $family);
	    	$template->assign( 'standalone',   $cfg_standalone );	
	    	$template->assign( 'family_id',   $family_id );	            
	    	$template->assign( 'action_page',   $_SERVER['PHP_SELF'] );	
  	        $template->run('family_add_member');						// Execute template
	    break;
	    	
	    case 'commit':
	        $approved      = $cfg_standalone ? 0 : 1;
	        family_add_parishioner( $family_id,$yob[0], $mob[0], $dob[0], $title[0], $first_name[0], $middle_name[0], $last_name[0], $email[0], $occupation[0], $gender[0],$mobile_phone[0], $primary_parish_id[0], $secondary_parish_id[0], $role[0], $approved, $home_number);
	        
	        //--------------------------------------------------------
            // Redirect to family_view_page to display details about the added family
            //--------------------------------------------------------
	        $t_url = 'family_view_page.php?family_id=' . $family_id ;
	        header_redirect( $t_url );
	    break; 
	    
	    case 'edit':
	        if($family_id == '')					                            // Family_id exists
            {
                trigger_error("Family_id is invalid",E_USER_ERROR);
                exit;
            }
            if($parishioner_id == '')					                        // parishioner_id exists
            {
                trigger_error("parishioner_id is invalid",E_USER_ERROR);
                exit;
            }
            
            access_ensure_not_standalone();

            $parishioner_id = gpc_get_int( 'parishioner_id', 0 );

            $parishioner = FALSE;

            // if valid id, then load info from database
            if ( Parishioner::is_valid_id( $parishioner_id ) && ( $parishioner_id != 0 ) )
            {
                $diocese_db->connect();
                $parishioner =& $diocese_db->parishioner_load( $parishioner_id );
            }

            // is parishioner not in db?
            if ( $parishioner === FALSE )    # if parishioner not found
            {
                $template->assign( 'parishioner_id', $parishioner_id );
                $template->run( 'parishioner_not_found' );
                exit;
            }

            $template->assign( 'parishioner',     $parishioner );       
            
            //#----------------------------------------------------------------------------------------------
	        //# DEFINE OR RETRIEVE DATA FOR PAGE
	        //#----------------------------------------------------------------------------------------------
	        $t_parishes = parish_get_id_name_map();                               // Get parish mapping (parish_inc.php)
	        $t_parish_ids = array_keys( $t_parishes );                            // Get Internal parish values
	        $t_parish_names = array_values( $t_parishes );                        // Get Parish Names for page

	        $t_secondary_parishes = parish_get_id_name_map( array(), false );     // Get all parishes (not just the accessible ones)
	        $t_secondary_parish_ids = array_keys( $t_secondary_parishes );        // Get Internal parish values
	        $t_secondary_parish_names = array_values( $t_secondary_parishes );    // Get Parish Names for page

	        $t_roles = family_member_get_role_id_name_map();			// Get Roler Mapping ( )
	        $t_role_ids = array_keys( $t_roles );					// Get Role Values
	        $t_role_names = array_values( $t_roles);				// Get Role Names
	        $t_genders = gender_get_id_name_map();				// Get Genders Mapping
	        $t_gender_ids = array_keys( $t_genders );				// Get Gender Values
	        $t_gender_names = array_values( $t_genders );				// Get Gender Names
	        $t_title_names = title_get_all();					// Get title values


	        //#----------------------------------------------------------------------------------------------
	        //# Prepare and Execute the template
	        //#----------------------------------------------------------------------------------------------
	        $template->assign( 'parish_ids',         $t_parish_ids );             // Assign values for 'parish_ids'
	        $template->assign( 'parish_names',       $t_parish_names );           // Assign values for 'parish_names'	       
	        $template->assign( 'secondary_parish_ids',   $t_secondary_parish_ids );   // Assign values for 'secondary_parish_ids'
	        $template->assign( 'secondary_parish_names', $t_secondary_parish_names ); // Assign values for 'secondary_parish_names'
	        $template->assign( 'role_ids',           $t_role_ids );               // Assign values for 'role_ids'
	        $template->assign( 'role_names',         $t_role_names );             // Assign values for 'role_names'
	        $template->assign( 'gender_ids',         $t_gender_ids );             // Assign values for 'gender_ids'
	        $template->assign( 'gender_names',       $t_gender_names );           // Assign values for 'gender_names'
	        $template->assign( 'title_names',        $t_title_names );            // Assign values for 'title_names'
	        //#----------------------------------------------------------------------------------------------
	        $template->assign( 'title',               'title[]' );                // Assign Field Name
	        $template->assign( 'first_name',          'first_name[]' );           // Assign Field Name
	        $template->assign( 'middle_name',         'middle_name[]' );          // Assign Field Name
	        $template->assign( 'last_name',           'last_name[]' );            // Assign Field Name
	        $template->assign( 'email',               'email[]' );                // Assign Field Name
                $template->assign( 'occupation',          'occupation[]' );           // Assign Field Name
	        $template->assign( 'mobile_phone',        'mobile_phone[]' );         // Assign Field Name
	        $template->assign( 'dob',                 'dob[]' );			// Assign Field Name
	        $template->assign( 'mob',                 'mob[]' );			// Assign Field Name
	        $template->assign( 'yob',                 'yob[]' );			// Assign Field Name
	        $template->assign( 'gender',              'gender[]' );		// Assign Field Name
	        $template->assign( 'primary_parish_id',   'primary_parish_id[]' );    // Assign Field Name
	        $template->assign( 'secondary_parish_id', 'secondary_parish_id[]' );  // Assign Field Name
	        $template->assign( 'family_id',           $family_id );                 // Assign Field Name
	        $template->assign( 'parishioner_id',      $parishioner_id );            
	        //#----------------------------------------------------------------------------------------------


            $template->assign( 'action_page',   $_SERVER['PHP_SELF'] );	
  	        $template->run('family_edit_member');						// Execute template
	    break;
	    
	    case 'update':
	    
	        family_update_parishioner( $family_id,$parishioner_id,$title[0],$first_name[0],$middle_name[0],$last_name[0],$dodec,$modec,$yodec,$dob[0],$mob[0],$yob[0],$mobile_phone[0],$day_time_phone,$email[0],$occupation[0],$doannul,$moannul,$yoannul,$primary_parish_id[0],$secondary_parish_id[0],$gender[0]);
	        
	        //--------------------------------------------------------
            // Redirect to parishioner_view_page to display details about the added family
            //--------------------------------------------------------
           
	        $t_url = 'parishioner_view_page.php?parishioner_id=' . $parishioner_id ;
	        header_redirect( $t_url );
	    break;
	    
		default:
		        trigger_error("Illegal Action",E_USER_ERROR);
                exit;
		break;
	}

    

  
?>
