<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: parishioner_list_page.php,v 1.12 2004/10/14 10:50:36 vboctor Exp $
    # -------------------------------------------------------------------------

    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'parishioner_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'utils_api_inc.php' );
    require_once( $t_src_path . 'gpc_api_inc.php' );
    require_once( $t_src_path . 'validate_au.php' );
    require_once( $t_src_path . 'access_api_inc.php' );
 
    access_ensure_not_standalone();

    define( 'ITEMS_PER_PAGE', 25 );

    $diocese_db->connect(); //connect to database

    disable_timeout();

    # Get Post Variables
    $f_parish_id     = gpc_get_string( 'parish_id',  '' );
    $f_first_name    = gpc_get_string( 'first_name', '' );
    $f_last_name     = gpc_get_string( 'last_name',  '' );
    $f_daytime_phone = gpc_get_string( 'daytime_phone', '' );
    $f_mobile_phone  = gpc_get_string( 'mobile_phone', '' );
    $f_approved      = gpc_get_int( 'approved', 1 );
    $f_page          = gpc_get_int( 'page_number', 1 );

    # Escape variables before injecting them in SQL
    $sql_parish_id     = db_prepare_string( $f_parish_id );
    $sql_first_name    = db_prepare_string( $f_first_name );
    $sql_last_name     = db_prepare_string( $f_last_name );
    $sql_daytime_phone = db_prepare_string( '%' . Validate_AU::_normalisePhoneNumber( $f_daytime_phone ) . '%' );
    $sql_mobile_phone  = db_prepare_string( Validate_AU::_normalisePhoneNumber( $f_mobile_phone ) );
    $sql_approved      = db_prepare_string( $f_approved );

    if ( $f_page < 1 )
        $f_page = 1;

    $t_core_parishioners = table( 'core_parishioners' );
    $t_core_parishes = table( 'core_parishes' );

    $query = "SELECT __PUT_SELECT_PORTION_HERE__
                     FROM $t_core_parishioners as parishioners, $t_core_parishes as parishes
                     WHERE ( parishioners.primary_parish_id = parishes.parish_id ) AND
                           ( parishioners.approved = $sql_approved )";

    if ( access_limited_to_one_parish() )
    {
        $query .= " AND parishes.parish_id = " . access_get_parish_id();
    }
    else if ( !is_blank2( $sql_parish_id ) )
    {
        $query .= " AND parishes.parish_id = $sql_parish_id";
    }

    if( !is_blank2( $sql_first_name ) )
    {
        $query .= " AND first_name = $sql_first_name";
    }
	
    if ( !is_blank2( $sql_last_name ) )
    {
        $query .= " AND last_name = $sql_last_name";
    }

    if ( !is_blank2( $sql_daytime_phone ) )
    {
        $query .= " AND daytime_phone like $sql_daytime_phone";
    }
	
    if ( !is_blank2( $sql_mobile_phone ) )
    {
        $query .= " AND mobile_phone = $sql_mobile_phone";
    }
	
    $t_count_query = str_replace( '__PUT_SELECT_PORTION_HERE__', 'COUNT( DISTINCT parishioner_id )', $query );

    $t_count = $diocese_db->get_one( $t_count_query );
    $t_num_of_pages = (integer) ( $t_count / ITEMS_PER_PAGE );
    $t_num_of_pages += ( $t_count % ITEMS_PER_PAGE ) == 0 ? 0 : 1;

    $query = str_replace( '__PUT_SELECT_PORTION_HERE__', 'DISTINCT( parishioner_id )', $query );

    # Sort by first name then last name
    $query .= " ORDER BY first_name ASC, last_name ASC";

    $recordSet = &$diocese_db->execute( $query, ITEMS_PER_PAGE, ( $f_page - 1 ) * ITEMS_PER_PAGE );

    # Collect parishioners' info into an array to send to template
    $parishioners = array();
    while ( !$recordSet->EOF )
    {
        $parishioner_id = $recordSet->fields['parishioner_id'];
        $parishioner = $diocese_db->parishioner_load( $parishioner_id );
        $parishioners[] = $parishioner;
        $recordSet->MoveNext();  //  Moves to the next row
    }  // end while

    # Prepare GET variables
    $t_get_vars = "parish_id=$f_parish_id&first_name=$f_first_name&last_name=$f_last_name&daytime_phone=$f_daytime_phone&mobile_phone=$f_mobile_phone&approved=$f_approved";

    $t_page_links = string_page_links( $_SERVER['PHP_SELF'] . "?$t_get_vars", 1, $t_num_of_pages, $f_page );

    # Execute the template
    $template->assign( 'parishioners',    $parishioners );
    $template->assign( 'page_links',      $t_page_links );

    $template->run( 'parishioners_list_page' );
?>