<?php
    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src/';

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'parish_inc.php' );
    require_once( $t_src_path . 'utils_api_inc.php' );
    require_once( $t_src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    $diocese_db->connect();
 
    if ( access_limited_to_one_parish() )
        $t_parishes = parish_get_id_name_map();  
    else
        $t_parishes = parish_get_id_name_map( array( '' => 'any' ) );  

    $t_parish_ids = array_keys( $t_parishes );
    $t_parish_names = array_values( $t_parishes );

    # Prepare and Execute the template

    $template->assign( 'action_page',   'parishioner_list_page.php' );
    $template->assign( 'parish_ids',    $t_parish_ids );
    $template->assign( 'parish_names',  $t_parish_names );
    $template->assign( 'parish_id',     'parish_id' );
    $template->assign( 'first_name',    'first_name' );
    $template->assign( 'last_name',     'last_name' );
    $template->assign( 'daytime_phone', 'daytime_phone' );
    $template->assign( 'mobile_phone',  'mobile_phone' );

    $template->run( 'parishioners_search_page' );
?> 	
