<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: parishioner_view_page.php,v 1.9 2004/04/02 23:54:28 vboctor Exp $
    # -------------------------------------------------------------------------

    $src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR;

    require_once( $src_path . 'common_inc.php' );
    require_once( $src_path . 'parishioner_inc.php' );
    require_once( $src_path . 'database_inc.php' );
    require_once( $src_path . 'address_inc.php' );
    require_once( $src_path . 'family_inc.php' );
    require_once( $src_path . 'family_member_inc.php' );
    require_once( $src_path . 'gpc_api_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    $parishioner_id = gpc_get_int( 'parishioner_id', 0 );

    $parishioner = false;

    # if valid id, then load info from database
    if ( Parishioner::is_valid_id( $parishioner_id ) && ( $parishioner_id != 0 ) )
    {
        $diocese_db->connect();
        $parishioner =& $diocese_db->parishioner_load( $parishioner_id );
    }

    # is parishioner not in db?
    if ( $parishioner === false )    # if parishioner not found
    {
        $template->assign( 'parishioner_id', $parishioner_id );
        $template->run( 'parishioner_not_found' );
        exit;
    }

    access_ensure_to_parishioner( $parishioner->get_id() );

    $c_parishioner_id = $diocese_db->prepare_int( $parishioner_id );

    $t_core_family_members = table( 'core_family_members' );

    $query = "SELECT * FROM $t_core_family_members WHERE parishioner_id = $c_parishioner_id";
    $recordSet = &$diocese_db->execute( $query );

    $families = array();
    $roles = array();
    while ( !$recordSet->EOF )
    {
        $family_id = $recordSet->fields['family_id'];
        $role = $recordSet->fields['role'];

        $family = $diocese_db->family_load( $family_id );

        $families[] = $family;
        $roles[] = $role;

        $recordSet->MoveNext();  //  Moves to the next row
    }  // end while

    $template->assign( 'parishioner',     $parishioner );
    $template->assign( 'families',        $families );
    $template->assign( 'roles',           $roles );
    $template->run( 'parishioner_view_page' );
?>