<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: priest_add_page.php,v 1.2 2004/04/02 23:54:28 vboctor Exp $
    # -------------------------------------------------------------------------

    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'utils_api_inc.php' );
    require_once( $t_src_path . 'gpc_api_inc.php' );
    require_once( $t_src_path . 'parishioner_inc.php' );
    require_once( $t_src_path . 'family_member_inc.php' );
    require_once( $t_src_path . 'parish_inc.php' );
    require_once( $t_src_path . 'priest_inc.php' );

    access_ensure_not_standalone();

    $f_parishioner_id = gpc_get_int( 'parishioner_id' );

    # @@@ Fields to set when someone becomes a priest
    # - Title
    # - First Name
    # - Primary Parish
    # - Ordainment Date

    $diocese_db->connect();

    # Priests have to be males
    $parishioner = parishioner_load( $f_parishioner_id );
    if ( $parishioner->get_gender() != 'M' ) {
        trigger_error ( "Priests must be males.", E_USER_ERROR );
        exit;
    }

    // Parishes
    $t_parishes = parish_get_id_name_map();
    $t_parish_ids = array_keys( $t_parishes );
    $t_parish_names = array_values( $t_parishes );

    // Prepare and Execute the template
    $template->assign( 'action_page',     'priest_add.php' );
    $template->assign( 'parish_ids',      $t_parish_ids );
    $template->assign( 'parish_names',    $t_parish_names );
    
    $template->assign( 'parish_id',           'parish_id' );
    $template->assign( 'first_name',          $parishioner->get_first_name() );
    $template->assign( 'date_of_ordainment',  'date_of_ordainment' );
    $template->assign( 'primary_parish_id',   $parishioner->get_primary_parish_id() );

    $template->run( 'priest_add_page' );
?>