# phpMyAdmin SQL Dump
# version 2.5.2-pl1
# http://www.phpmyadmin.net
#
# Host: localhost
# Generation Time: Sep 29, 2003 at 12:33 PM
# Server version: 4.0.14
# PHP Version: 4.3.2
# 
# Database : `eark`
# 

# --------------------------------------------------------

#
# Table structure for table `core_addresses`
#
# Creation: Sep 23, 2003 at 09:14 AM
# Last update: Sep 23, 2003 at 09:14 AM
#

CREATE TABLE `core_addresses` (
  `address_id` int(5) NOT NULL auto_increment,
  `street` char(100) NOT NULL default '',
  `suburb_id` int(5) NOT NULL default '0',
  PRIMARY KEY  (`address_id`),
  KEY `suburb_id` (`suburb_id`)
) TYPE=MyISAM COMMENT='Table of addresses';

#
# Dumping data for table `core_addresses`
#


# --------------------------------------------------------

#
# Table structure for table `core_countries`
#
# Creation: Sep 23, 2003 at 09:14 AM
# Last update: Sep 29, 2003 at 12:17 PM
#

CREATE TABLE `core_countries` (
  `country_id` int(3) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  PRIMARY KEY  (`country_id`)
) TYPE=MyISAM COMMENT='Table of countries in the diocese';

#
# Dumping data for table `core_countries`
#

INSERT INTO `core_countries` VALUES (1, 'Australia');

# --------------------------------------------------------

#
# Table structure for table `core_families`
#
# Creation: Feb 25, 2004 at 11:23 PM
# Last update: Feb 25, 2004 at 11:23 PM
#

CREATE TABLE `core_families` (
  `family_id` int(5) NOT NULL auto_increment,
  `last_name` varchar(20) NOT NULL default '',
  `address_id` int(5) NOT NULL default '0',
  `postal_address_id` int(5) NOT NULL default '0',
  `home_phone` varchar(20) NOT NULL default '',
  `home_phone2` varchar(20) NOT NULL default '',
  `home_fax` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`family_id`)
) TYPE=MyISAM COMMENT='Information about families';

#
# Dumping data for table `core_families`
#


# --------------------------------------------------------

#
# Table structure for table `core_family_members`
#
# Creation: Sep 23, 2003 at 09:14 AM
# Last update: Sep 23, 2003 at 12:20 PM
#

CREATE TABLE `core_family_members` (
  `member_id` int(8) NOT NULL auto_increment,
  `family_id` int(5) NOT NULL default '0',
  `parishioner_id` int(8) NOT NULL default '0',
  `role` char(1) NOT NULL default '',
  PRIMARY KEY  (`member_id`),
  KEY `parishoners_family` (`parishioner_id`),
  KEY `family_id` (`family_id`)
) TYPE=MyISAM COMMENT='Information about family members';

#
# Dumping data for table `core_family_members`
#


# --------------------------------------------------------

#
# Table structure for table `core_parishes`
#
# Creation: Sep 23, 2003 at 09:14 AM
# Last update: Sep 23, 2003 at 12:20 PM
#

CREATE TABLE `core_parishes` (
  `parish_id` int(3) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `address_id` int(5) NOT NULL default '0',
  `postal_address_id` int(5) NOT NULL default '0',
  `phone` char(20) NOT NULL default '',
  `phone2` char(20) NOT NULL default '',
  `fax` char(20) NOT NULL default '',
  `website` char(50) NOT NULL default '',
  `email` char(50) NOT NULL default '',
  PRIMARY KEY  (`parish_id`)
) TYPE=MyISAM COMMENT='Information about parishes';

#
# Dumping data for table `core_parishes`
#


# --------------------------------------------------------

#
# Table structure for table `core_parishioners`
#
# Creation: Sep 23, 2003 at 11:44 AM
# Last update: Sep 23, 2003 at 12:20 PM
# Last check: Sep 23, 2003 at 11:44 AM
#

CREATE TABLE `core_parishioners` (
  `parishioner_id` int(8) NOT NULL auto_increment,
  `title` char(10) NOT NULL default '',
  `first_name` char(20) NOT NULL default '',
  `middle_name` char(20) NOT NULL default '',
  `last_name` char(20) NOT NULL default '',
  `email` char(50) NOT NULL default '',
  `date_of_birth` date default '0000-00-00',
  `date_of_decease` date default '0000-00-00',
  `gender` char(1) NOT NULL default '',
  `daytime_phone` char(20) NOT NULL default '',
  `mobile_phone` char(20) NOT NULL default '',
  `date_of_annulment` date default '0000-00-00',
  `primary_parish_id` int(3) NOT NULL default '0',
  `secondary_parish_id` int(3) NOT NULL default '0',
  PRIMARY KEY  (`parishioner_id`),
  KEY `primary_parish_id` (`primary_parish_id`),
  KEY `secondary_parish_id` (`secondary_parish_id`),
  KEY `date_of_birth` (`date_of_birth`)
) TYPE=MyISAM;

#
# Dumping data for table `core_parishioners`
#


# --------------------------------------------------------

#
# Table structure for table `core_postal_addresses`
#
# Creation: Sep 23, 2003 at 09:14 AM
# Last update: Sep 23, 2003 at 09:14 AM
#

CREATE TABLE `core_postal_addresses` (
  `postal_address_id` int(5) NOT NULL auto_increment,
  `line1` varchar(30) NOT NULL default '',
  `line2` varchar(30) NOT NULL default '',
  `line3` varchar(30) NOT NULL default '',
  `country_id` int(3) NOT NULL default '0',
  PRIMARY KEY  (`postal_address_id`)
) TYPE=MyISAM COMMENT='Table for postable addresses (not used for statistical queri';

#
# Dumping data for table `core_postal_addresses`
#


# --------------------------------------------------------

#
# Table structure for table `core_priests`
#
# Creation: Sep 23, 2003 at 10:47 AM
# Last update: Sep 23, 2003 at 10:47 AM
#

CREATE TABLE `core_priests` (
  `priest_id` int(3) NOT NULL auto_increment,
  `parishioner_id` int(8) NOT NULL default '0',
  `date_of_ordainment` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`priest_id`)
) TYPE=MyISAM COMMENT='Table of all priests';

#
# Dumping data for table `core_priests`
#


# --------------------------------------------------------

#
# Table structure for table `core_states`
#
# Creation: Sep 29, 2003 at 12:06 PM
# Last update: Sep 29, 2003 at 12:17 PM
#

CREATE TABLE `core_states` (
  `state_id` int(3) NOT NULL auto_increment,
  `initials` char(3) NOT NULL default '',
  `country_id` int(3) NOT NULL default '0',
  PRIMARY KEY  (`state_id`)
) TYPE=MyISAM COMMENT='Table of Australian States';

#
# Dumping data for table `core_states`
#

INSERT INTO `core_states` VALUES (1, 'NSW', 1);
INSERT INTO `core_states` VALUES (2, 'QLD', 1);
INSERT INTO `core_states` VALUES (3, 'SA', 1);
INSERT INTO `core_states` VALUES (4, 'WA', 1);
INSERT INTO `core_states` VALUES (5, 'ACT', 1);
INSERT INTO `core_states` VALUES (6, 'NT', 1);

# --------------------------------------------------------

#
# Table structure for table `core_suburbs`
#
# Creation: Sep 29, 2003 at 11:38 AM
# Last update: Sep 29, 2003 at 11:38 AM
#

CREATE TABLE `core_suburbs` (
  `suburb_id` int(5) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  `state_id` int(3) NOT NULL default '0',
  `post_code` int(4) NOT NULL default '0',
  PRIMARY KEY  (`suburb_id`),
  UNIQUE KEY `name` (`name`,`post_code`)
) TYPE=MyISAM COMMENT='List of valid suburbs to be used in addresses';

#
# Dumping data for table `core_suburbs`
#

    
