<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: common_inc.php,v 1.10 2004/04/15 12:56:35 vboctor Exp $
    # -------------------------------------------------------------------------

    error_reporting( E_ALL );

    $main_path = dirname( dirname( __FILE__ ) ) . DIRECTORY_SEPARATOR;
    $src_path  = $main_path . 'src' . DIRECTORY_SEPARATOR;

    # Constant for our minimum required PHP version
    define( 'PHP_MIN_VERSION', '4.1.0' );

    require_once( $src_path . 'php_inc.php' );
    require_once( $src_path . 'utils_api_inc.php' );

    if ( !php_version_at_least( PHP_MIN_VERSION ) )
    {
        trigger_error( 'PHP version too old, minimum requirement is PHP v' . PHP_MIN_VERSION, E_USER_ERROR );
        exit;
    }

    //
    // Load Default Configuration
    //

    require_once( $src_path . 'config_defaults_inc.php' );

    //
    // Custom Configuration
    //

    if ( file_exists( $src_path  . 'config_inc.php' ) )
        include_once( $src_path  . 'config_inc.php' );

    //
    // Error Handling
    //

    require_once( $src_path . 'error_inc.php' );

    //
    // Validate configurations and adjust them if necessary
    //

    if ( !$cfg_debug )
    {
        $cfg_smarty_debug = false;
        $cfg_email_debug  = false;
    }

    //
    // Setup Smarty Template Engine
    //

    require_once( $src_path . 'templates_inc.php' );

    $template = new Template;
    $template->assign( 'webmaster_email', $cfg_webmaster_email );

    //
    // Common Include Files
    //

    require_once( $src_path . 'database_inc.php' );
    require_once( $src_path . 'parishioner_inc.php' );
    require_once( $src_path . 'family_inc.php' );
    require_once( $src_path . 'family_member_inc.php' );
    require_once( $src_path . 'parish_inc.php' );
    require_once( $src_path . 'priest_inc.php' );
    require_once( $src_path . 'address_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );
    require_once( $src_path . 'date_inc.php' );
    require_once( $src_path . 'utils_api_inc.php' );
    require_once( $src_path . 'gpc_api_inc.php' );
    require_once( $src_path . 'validate_au.php' );

    //
    // Diocese Database
    //

    $diocese_db =& new DioceseDB;
?>