<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: config_defaults_inc.php,v 1.17 2004/04/15 12:56:35 vboctor Exp $
    # -------------------------------------------------------------------------

    //----------------------------------------------------------------------
    // Database Configuration Parameters
    //----------------------------------------------------------------------

    $cfg_database_type = 'mysql';
    $cfg_database_host = 'localhost';
    $cfg_database_name = '';
    $cfg_database_user = '';
    $cfg_database_password = '';
    $cfg_tables_prefix = '';  // eg: ''->core_parishes, 'x'->x_core_parishes

    //----------------------------------------------------------------------
    // Debugging
    //----------------------------------------------------------------------

    // Setting this flag to false, disabled all other debugging flags
    // :TODO: Default these back to false when we start releasing versions of e-Ark
    $cfg_debug = true;
    $cfg_smarty_debug = true;

    // Setting this to an email address would send all emails to it
    // rather than the actual address.  The send emails will include
    // the original addresses as part of the body.  To disable
    // debugging set this option to false.
    $cfg_email_debug = false;
 
    //----------------------------------------------------------------------
    // Paths
    //----------------------------------------------------------------------

    $cfg_packages_path = dirname( dirname( __FILE__ ) ) . DIRECTORY_SEPARATOR . 'packages' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // PEAR Integration
    //----------------------------------------------------------------------

    $cfg_pear_path = $cfg_packages_path . 'PEAR-1.2.1' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // ADO DB Integration
    //----------------------------------------------------------------------

    $cfg_adodb_path = $cfg_packages_path . 'adodb-3.70' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // Smarty Integration
    //----------------------------------------------------------------------

    // Path that contains class.Smarty.php.  Must be terminated by a 
    // directory separator.
    $cfg_smarty_path = $cfg_packages_path . 'smarty' .
                       DIRECTORY_SEPARATOR . 'libs' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // PHPMailer Integration
    //----------------------------------------------------------------------

    // Path that contains class.phpmailer.php / class.smtp.php
    // must be terminated by a directory separator
    $cfg_phpmailer_path = $cfg_packages_path . 'phpmailer' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // vCard Integration
    //----------------------------------------------------------------------

    $cfg_vcard_path = $cfg_packages_path . 'vcard' . DIRECTORY_SEPARATOR;

    //----------------------------------------------------------------------
    // Email Configuration
    //----------------------------------------------------------------------

    $cfg_smtp_server = 'localhost';
    $cfg_smtp_auth = false;
    $cfg_smtp_username = '';
    $cfg_smtp_password = '';

    $cfg_webmaster_email = 'admin@example.com';

    //----------------------------------------------------------------------
    // Site Specific Settings
    //----------------------------------------------------------------------

    $cfg_title = 'Diocese of Sydney and Affiliated Regions';
    $cfg_sub_title = 'Parishioners Database Project';
    $cfg_parish_name = '';

    //----------------------------------------------------------------------
    // Misc. Configuration
    //----------------------------------------------------------------------

    $cfg_timestamp_format = 'd-M-Y H:i';
    $cfg_date_format = 'd-M-Y';
    $cfg_allow_import_data = false;
    $cfg_allow_purge_db = false;
    $cfg_standalone = false;

    // for the following line to be useful, it has to be copied to config_inc.php 
    // to calculate based on the configured values.  The other option is to assign
    // it a value that doesn't depend on other configs.
    $cfg_encryption_token = $cfg_database_name . $cfg_database_user . $cfg_database_password . $cfg_tables_prefix;
?>