<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: email_inc.php,v 1.2 2004/02/26 13:39:32 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( $cfg_phpmailer_path . 'class.phpmailer.php' );

    /**
     * Email class is used to enable the application to send emails.
     * This class acts as a standard interface that is used by the 
     * application for sending emails.  The fact that PHPMailer is
     * used should be totally hidden form the rest of the application.
     *
     * Only pages that need to send emails should include this file.
     */
    class Email
    {
        /**
         * Constructor
         *
         * Initialise PHPMailer with the appropriate configuration.
         * This will save the caller from having to set this up on
         * each object.
         */
        function Email()
        {
            global $cfg_emails_sender_address, $cfg_emails_sender_name,
                   $cfg_smtp_server, $cfg_smtp_auth,
                   $cfg_smtp_username, $cfg_smtp_password;

            $this->_phpmailer = new PHPMailer;
            $this->_phpmailer->From = $cfg_emails_sender_address;
            $this->_phpmailer->FromName = $cfg_emails_sender_name;
            $this->_phpmailer->PluginDir = $cfg_phpmailer_path;
            $this->_phpmailer->Mailer = 'smtp';

            $this->_phpmailer->Host = $cfg_smtp_server;
            $this->_phpmailer->SMTPAuth = $cfg_smtp_auth;
            $this->_phpmailer->Username = $cfg_smtp_username;
            $this->_phpmailer->Password = $cfg_smtp_password;
        }

        /**
         * Sends an email according to the specified parameters.
         *
         * @param $to       String/Array of Strings/Empty
         * @param $cc       String/Array of Strings/Empty
         * @param $subject  Email subject, can't be empty.
         * @param $body     Email body (text)
         * @param $attach   String/Array of Strings/null (file names)
         */
        function Send( $to, $cc, $bcc, $subject, $body, $attach = null )
        {
            // :TODO: Not yet implemented;
            echo Email::Send not yet implemented";
            exit;
        }

        //
        // Private
        //

        var $_phpmailer;
    }
?>