<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: error_inc.php,v 1.2 2004/03/27 11:57:00 vboctor Exp $
    # -------------------------------------------------------------------------

    # set up error_handler() as the new default error handling function
    set_error_handler( 'error_handler' );

    # ---------------
    # Default error handler
    #
    # This handler will not receive E_ERROR, E_PARSE, E_CORE_*, or E_COMPILE_*
    #  errors.
    #
    # E_USER_* are triggered by us and will contain an error constant in $p_error
    # The others, being system errors, will come with a string in $p_error
    #
    function error_handler( $p_type, $p_error, $p_file, $p_line, $p_context )
    {
        $t_short_file = basename( $p_file );
        $t_method = 'none';

        # build an appropriate error string
        switch ( $p_type ) {
            case E_WARNING:
                $t_error_type = 'SYSTEM WARNING';
                $t_error_description = $p_error;
                $t_method = 'inline';
                break;
            case E_NOTICE:
                $t_error_type = 'SYSTEM NOTICE';
                $t_error_description = $p_error;
                $t_method = 'inline';
                break;
            case E_USER_ERROR:
                $t_error_type = "APPLICATION ERROR";
                $t_error_description = $p_error;
                $t_method = 'halt';
                break;
            case E_USER_WARNING:
                $t_error_type = "APPLICATION WARNING";
                $t_error_description = $p_error;
                $t_method = 'inline';
                break;
            case E_USER_NOTICE:
                # used for debugging
                $t_error_type = 'DEBUG';
                $t_error_description = $p_error;
                $t_method = 'inline';
                break;
            default:
                #shouldn't happen, just display the error just in case
                $t_error_type = '';
                $t_error_description = $p_error;
        }

        $t_error_description = nl2br( htmlentities( $t_error_description ) );

        if ( 'halt' == $t_method ) {
            # $t_old_contents = ob_get_contents();
            # ob_end_clean() still sems to call the output handler which
            #  outputs the headers indicating compression. If we had
            #  PHP > 4.2.0 we could use ob_clean() instead but as it is
            #  we need to disable compression.
            # compress_disable();

            # if ( ob_get_length() ) { 
            #     ob_end_clean();
            # }

            echo '<br /><div align="center"><table class="width50" cellspacing="1">';
            echo "<tr><td class=\"form-title\">$t_error_type</td></tr>";
            echo "<tr><td><p class=\"center\" style=\"color:red\">$t_error_description</p></td></tr>";

            echo '<tr><td><p class="center">';
            echo 'Please use the "Back" button in your web browser to return to the previous page.  There you can correct whatever problems were identified in this error or select another action.  You can also click an option from the menu bar to go directly to a new section.';
            echo '</p></td></tr>';
            exit;
        } else if ( 'inline' == $t_method ) {
            echo "<p style=\"color:red\">$t_error_type: $t_error_description</p>";
        } else {
            # do nothing
        }
    }
?>