<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: modifier.family.php,v 1.2 2004/02/26 13:39:32 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( 'modifier.string_display.php' )

    /**
     * A smarty modifier to be used to display family names and
     * automatically have them hyper-linked to the page that views
     * family information.
     *
     * @param $p_family_id   Internal id of the family.
     * @param $p_caption     Caption to display for the family
     *
     * @return a hyperlinked string that links to the view family page.
     */
    function smarty_modifier_family( $p_family_id, $p_caption = null )
    {
        // if no caption is supplied, use the id as caption as well.
        if ( null === $p_caption )
            $p_cation = $p_family_id;

        $p_caption = smarty_modifier_string_display( $p_caption );

        // :TODO: Still to be implemented
        return "family.php?family=$p_family_id";
    }
?>