<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: modifier.not_empty.php,v 1.2 2004/02/26 13:39:32 vboctor Exp $
    # -------------------------------------------------------------------------

    /**
     * A modifier to be used when printing a string inside a table cell that has
     * a border.  If this modifier is not used, empty strings or strings with
     * only spaces will cause the borders of the cell not to be rendered correctly.
     *
     * Note that this modifier removes spaces.  If after trimming the string is 
     * empty, then the returned string is a non-blank space (&nbsp;).
     *
     * Usage: <td>$var|not_empty</td>
     */
    function smarty_modifier_not_empty( $p_string )
    {
        $p_string = trim( $p_string );
        if ( $p_string === '' )
           return '&nbsp;';

        return $p_string;
    }
?>