<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: modifier.parish_id_to_name.php,v 1.3 2004/04/03 15:09:00 vboctor Exp $
    # -------------------------------------------------------------------------

    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'parish_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );

    /**
     * This modifier converts a parish id to name
     *
     * Usage: $parish_id|parish_id_to_name
     */
    function smarty_modifier_parish_id_to_name( $p_parish_id )
    {
        global $diocese_db;

        $parish = $diocese_db->parish_load( $p_parish_id );
        if ( $parish === false )
        {
            return '';
        }

        $t_name = $parish->get_name();

        if ( access_is_standalone() )
            return $t_name;

        $t_parish_id = (integer)$p_parish_id;

        return "<a href=\"parish_view_page.php?parish_id=$t_parish_id\">$t_name</a>";
    }
?>