<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: php_inc.php,v 1.1 2004/03/22 12:42:43 vboctor Exp $
    # -------------------------------------------------------------------------

    /**
     * Given a version string this function checks if the installed PHP version
     * is this version or higher.
     *
     * @param $p_version_string  Version to check for (eg: '4.3.0')
     *
     * @retval true  Version is equal to or higher than the supplied version.
     * @retval false inferior version installed.
     */
    function php_version_at_least( $p_version_string )
    {
        $t_curver = array_pad( explode( '.', phpversion() ), 3, 0 );
        $t_minver = array_pad( explode( '.', $p_version_string ), 3, 0 );

        for ($i = 0 ; $i < 3 ; $i = $i + 1 )
        {
            if ( (int)$t_curver[$i] < (int)$t_minver[$i] ) {
                return false;
            } else if ( (int)$t_curver[$i] > (int)$t_minver[$i] ) {
                return true;
            }
        }

        # if we get here, the versions must match exactly so:
        return true; 
    }

    if ( !function_exists( 'array_fill' ) )
    {
        function array_fill($start, $len, $value)
        {
            $result = array();
            for ( $i = $start; $i < $len + $start; $i++ )
                $result[$i] = $value;

            return $result;
        }
    }
?>