<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003  e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: templates_inc.php,v 1.5 2004/03/20 12:26:56 vboctor Exp $
    # -------------------------------------------------------------------------

    $smarty_inc = $cfg_smarty_path . 'Smarty.class.php';
    require_once( $smarty_inc );

    /**
     * Template class inherits from Smarty class to customise it for
     * our usage.
     */
    class Template extends Smarty
    {
        /**
         * Constructor
         */
        function Template()
        {
            global $main_path, $cfg_smarty_path, $cfg_smarty_debug, $src_path,
                   $cfg_title, $cfg_sub_title;

            $this->template_dir = $main_path . 'templates' . DIRECTORY_SEPARATOR;
            $this->compile_dir = $main_path . 'templates_c' . DIRECTORY_SEPARATOR;
            $this->plugins_dir = array( $src_path, $cfg_smarty_path . 'plugins' . DIRECTORY_SEPARATOR );
            // $this->cache_dir = $main_path . 'cache' . DIRECTORY_SEPARATOR;
            $this->debugging = false;
            $this->debugging_ctrl = $cfg_smarty_debug ? 'URL' : 'NONE';    // Add ?SMARTY_DEBUG to URL to see debug info
            $this->compile_check = $cfg_smarty_debug;
            $this->force_compile = $cfg_smarty_debug;
            $this->load_filter( 'output', 'trimwhitespace' );

            $this->assign( 'header_title', $cfg_title );
            $this->assign( 'header_sub_title', $cfg_sub_title );
        }

        /**
         * Display a smarty template given its name
         *
         * @param $p_template Name of template not including path or extension
         */
        function run( $p_template )
        {
            global $main_path;
            $template_name = $p_template . '.tpl';
            $this->display( $template_name );
        }
    };
?>