<?php

require_once 'AU.php';



$_Validate_failure_count = 0;

$_Validate_success_count = 0;



function test($exp, $expected, $line)

{

    global $_Validate_failure_count, $_Validate_success_count;



	$returned = eval('return (' . $exp . ');');

    if ( $returned !== $expected ) {

        echo "Line #$line: FAILED: $exp\n";

        echo "\tExpected:\r\n\t\t";

        var_dump($expected);

        echo "\tReturned:\r\n\t\t";

        var_dump($returned);

        $_Validate_failure_count++;

    } else {

        $_Validate_success_count++;

    }

}



// echo Validate_AU::mapToShortStreetType('street') . "\r\n";



// Testing Valid States

test("Validate_AU::isValidState('nsw')", true, __LINE__);

test("Validate_AU::isValidState('NSW')", true, __LINE__);

test("Validate_AU::isValidState('  NSW ')", true, __LINE__);

test("Validate_AU::isValidState('  N.S.W  ')", true, __LINE__);

test("Validate_AU::isValidState('N S W')", true, __LINE__);

test("Validate_AU::isValidState('N.S.W.')", true, __LINE__);

test("Validate_AU::isValidState(' N. S. W. ')", true, __LINE__);

test("Validate_AU::isValidState('  vic')", true, __LINE__);

test("Validate_AU::isValidState('  v.i.c. ')", true, __LINE__);

test("Validate_AU::isValidState('qlD')", true, __LINE__);

test("Validate_AU::isValidState('s a')", true, __LINE__);

test("Validate_AU::isValidState('n.t.')", true, __LINE__);

test("Validate_AU::isValidState(' w a ')", true, __LINE__);

test("Validate_AU::isValidState('TAS')", true, __LINE__);

test("Validate_AU::isValidState('Act')", true, __LINE__);



// Testing Invalid States

test("Validate_AU::isValidState('.N.S.W.')", false, __LINE__);

test("Validate_AU::isValidState('N.S.W..')", false, __LINE__);

test("Validate_AU::isValidState('xyz')", false, __LINE__);

test("Validate_AU::isValidState('')", false, __LINE__);

test("Validate_AU::isValidState('   ')", false, __LINE__);



// Testing NSW Post Codes

test("Validate_AU::isValidPostCode('NSW', 2224)", true, __LINE__);

test("Validate_AU::isValidPostCode('NSW', 2228)", true, __LINE__);

test("Validate_AU::isValidPostCode('NSW', 7000)", false, __LINE__);



// QLD Tests

test("Validate_AU::isValidPostCode('q.L.d.', 4075)", true, __LINE__);

test("Validate_AU::isValidPostCode('q.L.d.', 2224)", false, __LINE__);



// Testing SA Post Codes

test("Validate_AU::isValidPostCode('SA', 872)", true, __LINE__);

test("Validate_AU::isValidPostCode('SA', -872)", false, __LINE__);



test("Validate_AU::mapToShortStreetType('')", '', __LINE__);

test("Validate_AU::mapToShortStreetType('street')", 'ST', __LINE__);

test("Validate_AU::mapToShortStreetType(' st. ')", 'ST', __LINE__);

test("Validate_AU::mapToShortStreetType(' xyz ')", false, __LINE__);

test("Validate_AU::mapToShortStreetType(' road ')", 'RD', __LINE__);

test("Validate_AU::mapToShortStreetType('parade')", 'PDE', __LINE__);

test("Validate_AU::mapToShortStreetType('pde.')", 'PDE', __LINE__);



test("Validate_AU::isValidMobileNumber('0400000000')", '0400000000', __LINE__);

test("Validate_AU::isValidMobileNumber('0400 000 000')", '0400000000', __LINE__);

test("Validate_AU::isValidMobileNumber('+61400 000 000')", '0400000000', __LINE__);

test("Validate_AU::isValidMobileNumber('+(61)400 000 000')", '0400000000', __LINE__);

test("Validate_AU::isValidMobileNumber('0061400-000-000')", '0400000000', __LINE__);

test("Validate_AU::isValidMobileNumber('400000000')", false, __LINE__);

test("Validate_AU::isValidMobileNumber(0400000000)", false, __LINE__);



test("Validate_AU::isValidStreetName('box')", true, __LINE__);

test("Validate_AU::isValidStreetName('box road')", false, __LINE__);

test("Validate_AU::isValidStreetName('box rd')", false, __LINE__);

test("Validate_AU::isValidStreetName('Murray Island')", true, __LINE__);



test("Validate_AU::isValidNationalPhoneNumber('132132')", '132132', __LINE__);

test("Validate_AU::isValidNationalPhoneNumber('1-300-360360')", '1300360360', __LINE__);

test("Validate_AU::isValidNationalPhoneNumber('1 800 504 504')", '1800504504', __LINE__);

test("Validate_AU::isValidNationalPhoneNumber('1800 504 504')", '1800504504', __LINE__);

test("Validate_AU::isValidNationalPhoneNumber('133333333')", false, __LINE__);

test("Validate_AU::isValidNationalPhoneNumber('180022')", false, __LINE__);



test("Validate_AU::isValidSydneyPhoneNumber('180022')", false, __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('95440000')", '0295440000', __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('(02) 95440000')", '0295440000', __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('85440000')", '0285440000', __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('02-85440000')", '0285440000', __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('0395440000')", false, __LINE__);

test("Validate_AU::isValidSydneyPhoneNumber('02954400000')", false, __LINE__);



echo "$_Validate_success_count test(s) passed, $_Validate_failure_count test(s) failed.\r\n";

// echo md5(implode('', file("postcodes.csv")));

?>