<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: vcard.php,v 1.2 2004/04/02 23:54:28 vboctor Exp $
    # -------------------------------------------------------------------------

    $t_src_path = dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' . DIRECTORY_SEPARATOR;

    require_once( $t_src_path . 'common_inc.php' );
    require_once( $t_src_path . 'database_inc.php' );
    require_once( $t_src_path . 'parishioner_inc.php' );
    require_once( $t_src_path . 'family_inc.php' );
    require_once( $t_src_path . 'family_member_inc.php' );
    require_once( $t_src_path . 'address_inc.php' );
    require_once( $t_src_path . 'gpc_api_inc.php' );
    require_once( $t_src_path . 'vcard_inc.php' );

    access_ensure_not_standalone();

    $diocese_db->connect();

    $f_parishioner_id = gpc_get_int( 'parishioner_id' );
    $f_family_id = gpc_get_int( 'family_id', 0 );

    $vcard =& new ParishionerVirtualCard();

    $parishioner = $diocese_db->parishioner_load( $f_parishioner_id );
    if ( $parishioner !== false )
        $vcard->set_parishioner( $parishioner );

    if ( $f_family_id !== 0 )
    {
        $family = $diocese_db->family_load( $f_family_id );
        if ( $family !== false )
        {
            $vcard->set_family( $family );

            if ( $family->get_address_id() != 0 )
            {
                $address = $diocese_db->address_load( $family->get_address_id() );
                $vcard->set_address( $address );
            }
        }
    }

    $vcard->generate_file();
?>