<?php
    ###########################################################################
    #
    # eArk
    #
    # Copyright (C) 2003-2004 e-Ark Team - Diocese of Sydney and Affiliated Regions
    #
    # This program is distributed under the terms and conditions of the GPL
    # See the README and LICENSE files for details
    #
    ###########################################################################

    # -------------------------------------------------------------------------
    # $Id: visitation_report_page.php,v 1.3 2004/10/14 10:50:36 vboctor Exp $
    # -------------------------------------------------------------------------

    require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'src' .
                  DIRECTORY_SEPARATOR . 'common_inc.php' );
    require_once( $src_path . 'access_api_inc.php' );

    access_ensure_not_standalone();

    # Get GET Variables
    $f_format = gpc_get_string( 'format',  'html' );

    disable_timeout();

    $diocese_db->connect();

    #
    # Generic sort function to sort an array based on a field of its records.
    #

    $t_core_families = table( 'core_families' );
    $t_core_addresses = table( 'core_addresses' );
    $t_core_suburbs = table( 'core_suburbs' );
    $query = "SELECT family_id FROM $t_core_families f, $t_core_addresses a, $t_core_suburbs s WHERE approved=1 AND f.address_id = a.address_id AND a.suburb_id = s.suburb_id";

    if ( access_limited_to_one_parish() )
    {
        $query .= " AND f.parish_id = " . access_get_parish_id();
    }

    $query .= " ORDER BY s.name ASC, f.last_name ASC";

    $t_result = &$diocese_db->execute( $query );

	$t_families = array();

    while ( !$t_result->EOF )
    {
        $t_family_id = $t_result->fields['family_id'];
        $t_family = $diocese_db->family_load( $t_family_id );

		$t_family_members = $t_family->get_family_members();
		if ( count( $t_family_members ) == 0 )
			continue;

		// if role = H, then it will not enter loop.
		// if role = S, then there should be only one parishioner, hence, should not enter loop.
		$t_family_main_contact = $t_family_members[0];
		for ( $i = 1; ( $i < count( $t_family_members ) ) && ( $t_family_main_contact->get_role() != 'H' ); ++$i )
		{
			if ( $t_family_members[$i]->get_role() != 'C' )
				$t_family_main_contact = $t_family_members[$i];
		}
		
		$t_parishioner = $diocese_db->parishioner_load( $t_family_main_contact->get_parishioner_id() );

        $t_address_id = $t_family->get_address_id();
        $t_address = $diocese_db->address_load( $t_address_id );
        	
		$t_family_details = array();
		$t_family_details["Id"] = $t_family->get_id();
		$t_family_details["Surname"] = $t_family->get_last_name();
		$t_family_details["Contact"] = $t_parishioner->get_first_name();
		$t_family_details["Role"] = $t_family_main_contact->get_role();
		$t_family_details["Mobile"] = $t_parishioner->get_mobile_number();
		$t_family_details["HomePhone"] = $t_family->get_home_phone();
		$t_family_details["Street"] = $t_address->get_street_details();
		$t_family_details["Suburb"] = $t_address->get_suburb();

		$t_families_details[] = $t_family_details;

        $t_result->MoveNext();
    }

    # Execute the template
    $template->assign( 'families_details', $t_families_details );

    if ( $f_format === 'csv' )
    {
        $t_filename = 'visitation_report.csv';
        header( 'Content-Type: text/plain; name=' . $t_filename );
        header( 'Content-Transfer-Encoding: BASE64;');
        header( 'Content-Disposition: attachment; filename=' . $t_filename );
        $template->run( 'visitation_report_csv' );
    }
    else
    {
        $template->run( 'visitation_report_page' );
    }
?>